import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class testGather {
    static SpmdEnv spmd;
    static Procs2 p;
    static BlockRange t1;
    static BlockRange t2;
	static Range x, y;
    static Array2ddI a;
    static Range j;
    static int i = 10;

  public static void main(String argv[])
  {
    Array2cdI b, u, v, mask;

    spmd=new SpmdEnv(argv);
    p = new Procs2(3,2);

    t1 = new BlockRange(100, p.dim(0));
    t2 = new BlockRange(100, p.dim(1));
    // t2 = new BlockCyclicRange(100, p.dim(1), 10);

    x = t1.subrng(20, 15, 3) ;
    y = t2.subrng(15, 25, 5) ;

    a = new Array2ddI(p,x,y);
    j = t2.subrng(20,70, -2);

    b = new Array2cdI(p,i,j);
    u = new Array2cdI(p,i,j);
    v = new Array2cdI(p,i,j);
    mask = new Array2cdI(p,i,j);


    if(p.on()) {
      Index ix = new Index(x);
      Index iy = new Index(y);

      ix.dim().over();
      for (ix.begin(); ix.test(); ix.next()) {
        iy.dim().over();
        for (iy.begin(); iy.test(); iy.next()) {
          a.dat()[a.pos(ix,iy)] = 1000 * x.idx(ix) + y.idx(iy);
        } iy.dim().revo();
      } ix.dim().revo();

      Index ij = new Index(j);
      for(int ii = 0; ii < i; ii++) {
        ij.dim().over();
        for(ij.begin(); ij.test(); ij.next()) {
          b.dat()[b.pos(ii, ij)] = 0;
	      u.dat()[u.pos(ii, ij)] = (ii + j.idx(ij)) % 20 ;
	      v.dat()[v.pos(ii, ij)] = (ii + (30 - j.idx(ij))) % 15 ;
	      mask.dat()[mask.pos(ii, ij)] = (ii + j.idx(ij)) % 2 ;
        }ij.dim().revo();
      }
    } p.no();

  // System.out.println("testGather0:");
  Adlib.gather(b, a, u, v, mask);
  Adlib.aprintf("%3R0%3R1%10d\n", b) ;
  spmd.finalize();
  }
}
